<?php

include_once(dirname(__FILE__).'/../../Common/Global.php');

class PagePortal extends Page
{
  var $Dependencies = array('News');
  var $FullTitle = 'Zděchovský rozcestník';
  var $ShortTitle = '';
  
  function ShowLinks($HyperlinkGroup)
  {
    $Output = '';
    $DbResult = $this->Database->query('SELECT * FROM `Hyperlink` WHERE (`Group`='.$HyperlinkGroup['Id'].') AND (`Enable` = 1)');
    while($HyperLink = $DbResult->fetch_assoc())
    {
      if($HyperLink['IconFile'] == '') $HyperLink['IconFile'] = 'clear.png';
        if(substr($HyperLink['URL'], 0, 4) != 'http') $HyperLink['URL'] = $this->System->Config['Web']['RootFolder'].$HyperLink['URL'];
        if(($HyperLink['PermissionModule'] == '') or (($HyperLink['PermissionModule'] != '') and $this->System->Modules['User']->Models['User']->CheckPermission($HyperLink['PermissionModule'], $HyperLink['PermissionOperation'])))        
        $Output .= '<img alt="'.$HyperLink['Name'].'" src="images/favicons/'.$HyperLink['IconFile'].'" width="16" height="16" /> <a href="'.$HyperLink['URL'].'">'.$HyperLink['Name'].'</a><br />';
    }
    return($this->Panel($HyperlinkGroup['Name'], $Output));
  }

  function InfoBar()
  {
    global $Config;
    
    $this->Database->select_db($Config['Database']['Database']);

    $Output2 = '';

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE NetworkDeviceType.ShowOnline = 1');
    $DbRow = $DbResult->fetch_array();
    $TotalComputers = $DbRow[0];

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE (NetworkDeviceType.ShowOnline = 1) AND (NetworkDevice.Online = 1)');
    $DbRow = $DbResult->fetch_array();    
    $OnlineComputers = $DbRow[0];

    $Output = '<img alt="" src="images/favicons/comp.png" width="16" height="16" /> '.$OnlineComputers.' / '.$TotalComputers.' &nbsp;  &nbsp; ';

    $DbResult = $this->Database->select('Member', 'COUNT(*)', '1');
    $DbRow = $DbResult->fetch_array();
    $TotalUser = $DbRow[0];

    $DbResult = $this->Database->query('SELECT COUNT(DISTINCT(Member)) FROM NetworkDevice '.
      'LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type '.
      'WHERE NetworkDeviceType.ShowOnline = 1 AND NetworkDevice.Online = 1');
    $DbRow = $DbResult->fetch_array();
    $OnlineUser = $DbRow[0];

    $Output .= '<img alt="" src="images/favicons/house.png" width="16" height="16" /> '.$OnlineUser.' / '.$TotalUser.' &nbsp;  &nbsp; ';

    $NetworkUsage = 0;
    $Output .= '<img alt="" src="images/favicons/usage.png" width="16" height="16" /> '.$NetworkUsage.' % &nbsp;  &nbsp; ';

    //$Output .= 'Server běží: '.$this->GetServerUptime().' &nbsp;  &nbsp; ';

    if($this->System->Modules['User']->CheckPermission('Finance', 'DisplaySubjectState'))
    {
      $DbResult = $this->Database->select('MemberPayment', 'Cash', 'Member=(SELECT Customer FROM UserCustomerRel WHERE Id='.$this->System->Modules['User']->User['Id'].')');
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_assoc();
        $Output2 .= ' &nbsp;  &nbsp; <img alt="" src="images/favicons/money.png" width="16" height="16" /> '.$DbRow['Cash'].' Kč';
      }
    }

    $Output = '<div class="Navigation"><span class="MenuItem">'.$Output.'</span><div class="MenuItem2">&nbsp;'.$Output2.'</div></div>';
    return($Output);
  }

  function UserPanel()
  {
    $Output = '<a href="'.$this->System->Config['Web']['RootFolder'].'/?Action=UserOptions">Profil</a><br />';
    if($this->System->Modules['User']->CheckPermission('Finance', 'MemberOptions')) 
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'?Action=MemberOptions">Domácnost</a><br />';
    if($this->System->Modules['User']->CheckPermission('Finance', 'DisplaySubjectState')) 
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/finance/user_state.php">Finance</a><br />';
    if($this->System->Modules['User']->CheckPermission('Network', 'RegistredHostList')) 
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/network/user_hosts.php">Počítače</a><br />';
    if($this->System->Modules['User']->CheckPermission('News', 'Insert')) 
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/aktuality/?action=add">Vložení aktuality</a><br />';
    if($this->System->Modules['User']->CheckPermission('EatingPlace', 'Edit'))
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/jidelna/menuedit.php">Editace jídelníčků</a><br />';
    if($this->System->Modules['User']->CheckPermission('Finance', 'Manage'))
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/finance/manage.php">Správa financí</a><br />';
    if($this->System->Modules['User']->CheckPermission('Network', 'Administration'))
      $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/network/administration.php">Správa sítě</a><br />';
    if($this->System->Modules['User']->CheckPermission('IS', 'Manage'))
      $Output .= '<a href="'.$this->System->Link('/is/').'">Správa dat</a><br />';
    return($Output);
  }

  function WebcamPanel()
  {
    $Output = $this->System->ModuleManager->Modules['WebCam']->ShowImage();
    return($Output);
  }

  function OnlineHostList()
  {
    $Output = '<span style="font-size: smaller;">';
    $DbResult = $this->Database->query('SELECT NetworkDevice.Name FROM NetworkDevice LEFT JOIN NetworkDeviceType ON NetworkDeviceType.Id = NetworkDevice.Type WHERE (NetworkDeviceType.ShowOnline = 1) AND (NetworkDevice.Online = 1) ORDER BY NetworkDevice.Name');
    while($Device = $DbResult->fetch_array())
    {
      $Output .= $Device['Name'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }

  function ShowBadPayerList()
  {
    $Output .= '<div class="PanelTitle">Dlužníci:</div><span style="font-size: smaller;">';
    $DbResult = $Database->select('Subject', 'Name', 'Money < 0 ORDER BY Money');
    while($Row = $DbResult->fetch_array())
    {
      $Output .= $Row['Name'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }
   
  function Panel($Title, $Content, $Menu = array())
  {
    if(count($Menu) > 0) 
      foreach($Menu as $Item)
        $Title .= '<div class="Action">'.$Item.'</div>';
    return('<div class="Panel"><div class="Title">'.$Title.'</div><div class="Content">'.$Content.'</div></div>');
  }

  function Show()
  {
    global $Config, $User;

    $Output = '';
    if(array_key_exists('Action', $_GET))
    {
      if($_GET['Action'] == 'CustomizeNewsSave')
      {
        $Output .= $this->System->Modules['News']->CustomizeSave();
      } else
      if($_GET['Action'] == 'LoginForm')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserLogin');
        $Form->OnSubmit = '?Action=Login';
        $Output .= $Form->ShowEditForm();
        $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
        '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
      } else
      if($_GET['Action'] == 'Login')
      {
        if(array_key_exists('Username', $_POST) and array_key_exists('Password', $_POST))
        {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserLogin');
        $Form->OnSubmit = '?Action=Login';
        $Result = $this->System->Modules['User']->Login($_POST['Username'], $_POST['Password']);
        $Output .= $this->SystemMessage('Přihlášení', $Result);
        if($Result <> USER_LOGGED_IN)
        {
          $Form->LoadValuesFromForm();
          $Form->Values['Password'] = '';
          $Output .= $Form->ShowEditForm();
          $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
            '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
        }
        } else $Output .= $this->SystemMessage('Přihlášení', 'Nezadány přihlašovací údaje');
      } else 
      if($_GET['Action'] == 'Logout')
      {
        if($this->System->Modules['User']->User['Id'] != null)
        {
          $Output .= $this->SystemMessage('Odhlášení', $this->System->Modules['User']->Logout());
        } else $Output .= $this->SystemMessage('Nastavení uživatele', 'Nejste přihlášen');
      } else
      if($_GET['Action'] == 'UserOptions')
      { 
        if($this->System->Modules['User']->User['Id'] != null)
        {
          $UserOptions = new Form($this->System->FormManager);
          $UserOptions->SetClass('UserOptions');
          $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
          $UserOptions->OnSubmit = '?Action=UserOptionsSave';
          $Output .= $UserOptions->ShowEditForm();
        } else $Output .= $this->SystemMessage('Nastavení uživatele', 'Nejste přihlášen');
      } else
      if($_GET['Action'] == 'UserOptionsSave')
      {
        $UserOptions = new Form($this->System->FormManager);
        $UserOptions->SetClass('UserOptions');
        $UserOptions->LoadValuesFromForm();
        $UserOptions->SaveValuesToDatabase($this->System->Modules['User']->User['Id']);
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení uloženo.');
        $this->System->Modules['Log']->NewRecord('User', 'Nastavení uživatele změněno', $UserOptions->Values['Name']);
        $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=UserOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      }
      if($_GET['Action'] == 'UserRegister')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserRegister');
        //$Form->LoadValuesFromForm();
        $Form->OnSubmit = '?Action=UserRegisterSave';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserRegisterConfirm')
      {
        $Output .= $this->SystemMessage('Potvrzení registrace', 
          $this->System->Modules['User']->RegisterConfirm($_GET['User'], $_GET['H']));
      } else
      if($_GET['Action'] == 'PasswordRecovery')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('PasswordRecovery');
        $Form->OnSubmit = '?Action=PasswordRecovery2';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'PasswordRecovery2')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('PasswordRecovery');
        $Form->LoadValuesFromForm();
        $Result = $this->System->Modules['User']->PasswordRecoveryRequest($Form->Values['Name'], $Form->Values['Email']);
        $Output .= $this->SystemMessage('Obnova hesla', $Result);
        if($Result <> USER_PASSWORD_RECOVERY_SUCCESS)
        {
          $Output .= $Form->ShowEditForm();
        }        
      } else
      if($_GET['Action'] == 'PasswordRecoveryConfirm')
      {
        $Output .= $this->SystemMessage('Obnova hesla', $this->System->Modules['User']->PasswordRecoveryConfirm($_GET['User'], $_GET['H'], $_GET['P']));
      } else
      if($_GET['Action'] == 'UserRegisterSave')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('UserRegister');
        $Form->LoadValuesFromForm();
        $Result = $this->System->Modules['User']->Register($Form->Values['Login'], $Form->Values['Password'], $Form->Values['Password2'], $Form->Values['Email'], $Form->Values['Name'], $Form->Values['PhoneNumber'], $Form->Values['ICQ']);
        $Output .= $this->SystemMessage('Registrace nového účtu', $Result);
        if($Result <> USER_REGISTRATED) 
        {
          $Form->OnSubmit = '?Action=UserRegisterSave';
          $Output .= $Form->ShowEditForm();
        }
      } else
      if($_GET['Action'] == 'MemberOptions')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('MemberOptions');
        $DbResult = $this->Database->query('SELECT Customer FROM UserCustomerRel WHERE User='.$this->System->Modules['User']->User['Id']);
        if($DbResult->num_rows > 0)
        {
          $CustomerUserRel = $DbResult->fetch_assoc();
          $DbResult = $this->Database->query('SELECT Member.Id, '.
            'Member.FamilyMemberCount, Member.BillingPeriodNext, Subject.Name, Subject.AddressStreet, '.
            'Subject.AddressTown, Subject.AddressPSC, Subject.AddressCountry, Subject.IC, Subject.DIC FROM Member JOIN Subject '.
           'ON Subject.Id = Member.Subject WHERE Member.Id='.$CustomerUserRel['Customer']);        
          $DbRow = $DbResult->fetch_array();
          foreach($Form->Definition['Items'] as $Index => $Item)
          {
            $Form->Values[$Index] = $DbRow[$Index];
          }
          $Form->OnSubmit = '?Action=MemberOptionsSave';
          $Output .= $Form->ShowEditForm();
        } else $Output .= $this->SystemMessage('Chyba', 'Nejste zákazníkem');
      } else
      if($_GET['Action'] == 'MemberOptionsSave')
      {
        $Form = new Form($this->System->FormManager);
        $Form->SetClass('MemberOptions');
        $Form->LoadValuesFromForm();
        if($Form->Values['FamilyMemberCount'] < 0)
          $Form->Values['FamilyMemberCount'] = 0;
        if($Form->Values['BillingPeriodNext'] < 2)
          $Form->Values['BillingPeriodNext'] = 2;
          
        $DbResult = $this->Database->update('Member', 'Id='.$this->System->Modules['User']->User['Member'], 
           array('FamilyMemberCount' => $Form->Values['FamilyMemberCount'], 
           'BillingPeriodNext' => $Form->Values['BillingPeriodNext']));
        $DbResult = $this->Database->query('SELECT Subject FROM Member WHERE Id='.$this->System->Modules['User']->User['Member']);
        $Member = $DbResult->fetch_assoc();
        $DbResult = $this->Database->update('Subject', 'Id='.$Member['Subject'], 
          array('Name' => $Form->Values['Name'], 'AddressStreet' => $Form->Values['AddressStreet'], 
          'AddressTown' => $Form->Values['AddressTown'], 'AddressCountry' => $Form->Values['AddressCountry'],
          'AddressPSC' => $Form->Values['AddressPSC'], 'IC' => $Form->Values['IC'], 
          'DIC' => $UserOptions->Values['DIC']));
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení domácnosti uloženo.');
        $this->System->Modules['Log']->NewRecord('Member+Subject', 'Nastavení člena/subjektu změněno', 
          $Form->Values['Name']);
        $DbResult = $this->Database->query('SELECT Member.Id, Member.FamilyMemberCount, Member.BillingPeriodNext, '.
          'Subject.Name, Subject.AddressStreet, Subject.AddressTown, Subject.AddressPSC, '.
          'Subject.AddressCountry, Subject.IC, Subject.DIC FROM Member JOIN Subject '.
          'ON Subject.Id = Member.Subject WHERE Member.Id='.$this->System->Modules['User']->User['Member']);
        $DbRow = $DbResult->fetch_array();
        foreach($Form->Definition['Items'] as $Index => $Item)
        {
          $Form->Values[$Index] = $DbRow[$Index];
        }
        $Form->OnSubmit = '?Action=MemberOptionsSave';
        $Output .= $Form->ShowEditForm();
      }
    }

    $this->Database->select_db($Config['Database']['Database']);

    $DbResult = $this->Database->query('SELECT * FROM `HyperlinkGroup`');
    while($DbRow = $DbResult->fetch_assoc())
      $HyperlinkGroups[$DbRow['Id']] = $DbRow;

    // Show pannels
    //if(IsInternetAddr()) echo('Internet'); else echo('LAN');
    //$Output .= $this->InfoBar();
    $Output .= '<table id="MainTable"><tr>';
    $DbResult = $this->Database->select('PanelColumn', '*');
    while($PanelColumn =  $DbResult->fetch_assoc())
    {
      if($PanelColumn != '') $Width = ' width="'.$PanelColumn['Width'].'"'; 
        else $Width = '';
      $Output .= '<td valign="top"'.$Width.'>';
      $DbResult2 = $this->Database->query('SELECT * FROM `Panel` WHERE `PanelColumn`='.$PanelColumn['Id'].' ORDER BY `Order`');
      while($Panel = $DbResult2->fetch_assoc())
      {
        if($Panel['Module'] == 'HyperlinkGroup') $Output .= $this->ShowLinks($HyperlinkGroups[$Panel['Parameters']]);
        else if($Panel['Module'] == 'OnlineHostList') $Output .= $this->Panel('Online počítače', $this->OnlineHostList());
        else if($Panel['Module'] == 'UserOptions') 
        {
          if($this->System->Modules['User']->User['Id'] != null) $Output .= $this->Panel('Přihlášený uživatel', $this->UserPanel());
        } else
        if($Panel['Module'] == 'Webcam') $Output .= $this->Panel('Kamery', $this->WebcamPanel());
        else if($Panel['Module'] == 'NewsGroupList') $Output .= $this->Panel('Aktuality', $this->System->Modules['News']->Show(), array('<a href="?Action=CustomizeNews">Upravit</a>'));
      }
      $Output .= '</td>';
    }  
    $Output .= '</tr></table>';
    return($Output);
  }
}

class ModulePortal extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'Portal';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPLv3';
    $this->Description = 'Community portal.';
    $this->Dependencies = array();
  }  

  function Install()
  {
  }
  
  function Uninstall()
  {     
  }
  
  function Start()
  {
    parent::Start();
    $this->System->RegisterPage('', 'PagePortal');
  }  
  
  function Stop()
  { 
  } 
}

?>
